---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Friends","LEFT")
local btn = gb.Friends
btn.text		= "Friends"
btn.enabled		= true
btn.events		= {"BN_FRIEND_ACCOUNT_OFFLINE","BN_FRIEND_ACCOUNT_ONLINE","FRIENDLIST_UPDATE"}
btn.update		= true
btn.tooltip		= true
btn.click		= true

---------------------------
-- shortcuts
---------------------------
local HEX = ga.colors.HEX
local CLS = ga.colors.CLASS
local tooltip = gf.Tooltip

---------------------------
-- update
---------------------------
function gf.Friends.update()
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Friends")
		local _,WoWFriends = GetNumFriends()
		local _,RealFriends = BNGetNumFriends()
		gf.setButtonText(btn.button,"Friends: ",WoWFriends..","..RealFriends,nil,nil)
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Friends.tooltip()
	Glance.Debug("function","tooltip","Friends")
	local _,WoWFriends = GetNumFriends()
	local _,RealFriends = BNGetNumFriends()
	tooltip.Line(WoWFriends.." Friend(s) Online","GLD")
	for i = 0, GetNumFriends() do
		local name, level, class, area, connected, status, note = GetFriendInfo(i)
		if connected then
			local cls = string.upper(class)
			tooltip.Double(HEX[cls]..name.." ("..level.." "..class..")", area, "WHT", "WHT")
		end
	end
	tooltip.Space()
	tooltip.Line(RealFriends.." BattleNet Friend(s) Online","GLD")
	for j = 1, BNGetNumFriends() do
		local presenceID, presenceName,_,_,_,_, client,isOnline,_ = BNGetFriendInfo(j)
		local _, toonName, _, realmName, _, _, race, class, _, zoneName, level, gameText, _ = BNGetToonInfo(presenceID)
		local msg1, msg2 = "", ""
		if isOnline then
			clss = string.upper(class) or "PRIEST"
			if string.upper(client) == "WOW" then
				msg1 = HEX.lightblue..gf.ts(presenceName).." |r["..HEX.green..gf.ts(client).." - "..gf.ts(realmName).."|r]"
				msg2 = CLS[clss]..gf.ts(toonName).." |r("..HEX.green..gf.ts(level).." |r"..gf.ts(race).." "..CLS[clss]..gf.ts(class).."|r) "..HEX.darkblue..gf.ts(zoneName)
			else
				msg1 = HEX.lightblue..gf.ts(presenceName).." |r["..HEX.red..gf.ts(client).."|r]"
				msg2 = gf.ts(toonName).." "..gf.ts(gameText)
			end
			tooltip.Double(msg1, msg2, "WHT", "WHT")
		end
	end
	--(left,shift-left,right,shift-right,other)
	tooltip.Notes("open the Friends tab",nil,nil,nil,nil)
end

---------------------------
-- click
---------------------------
function gf.Friends.click(self, button, down)
	Glance.Debug("function","click","Friends")
	if button == "LeftButton" then
		ToggleFriendsFrame() --removed the value "1" from being passed to fix bug.
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Friends")
end