---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("TolBarad","LEFT")
local btn = gb.TolBarad
btn.text              = "Tol Barad"
btn.enabled           = true
btn.events            = {""}
btn.update            = true
btn.tooltip           = true
btn.menu              = true
btn.timer1            = true
btn.save.perAccount   = { ["ShortName"] = false }

---------------------------
-- shortcuts
---------------------------
local spa = btn.save.perAccount
local HEX = ga.colors.HEX
local tooltip = gf.Tooltip

---------------------------
-- variables
---------------------------
gv.TBSec = 0

---------------------------
-- update
---------------------------
function gf.TolBarad.update(self, event, arg1)
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		--Glance.Debug("function","update","Tol Barad")
		local name = gf.getCondition(spa.ShortName,"TB","Tol Barad")
		if WorldMapFrame:IsVisible() == nil then
			local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
			local inInstance, instanceType = IsInInstance()
			if inInstance and instanceType == "raid" then
				if gv.TBSec > 0 then
					gv.TBSec = gv.TBSec - 1
					sec = gv.TBSec
				else
					gv.TBSec = 0
				end
			else
				gv.TBSec = sec
			end
			local control = "|r"
			local area = GetCurrentMapAreaID()
			SetMapByID(708) --708 for tol barad - 485 for wg
			for i = 1, GetNumMapLandmarks() do
				local index = select(3, GetMapLandmarkInfo(i))
				if index == 46 then
					control = ga.colors.FACTION.alliance
				elseif index == 48 then
					control = ga.colors.FACTION.horde
				end
			end
			if not isActive then
				if sec < 60 and sec > 0 then -- 1 minute warning (seconds)
					btn.button:SetFormattedText("%s "..name..": "..HEX.red.."%d|rs", control, (sec or 0))
				elseif sec <= 300 then -- 5 minute warning (minutes)
					btn.button:SetFormattedText("%s "..name..": "..HEX.red.."%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 300 and sec <= 3600 then -- show minutes
					btn.button:SetFormattedText("%s "..name..": "..HEX.green.."%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 3600 then -- show hours
					local hour, min
					hour = (math.floor(sec/3600) or 0)
					min	= (math.floor((sec-(hour*3600))/60) or 0)
					btn.button:SetFormattedText("%s "..name..": "..HEX.green.."%d|rh "..HEX.green.."%d|rm", control, hour, min)
				end
			else -- in session
				btn.button:SetFormattedText(name..": "..HEX.red.."0|rm")
			end
			SetMapByID(area)
		end
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.TolBarad.tooltip()
	Glance.Debug("function","tooltip","Tol Barad")
	tooltip.Title("Tol Barad", "GLD")
	local area = GetCurrentMapAreaID()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
	local inInstance, instanceType = IsInInstance()
	local control = "|r"
	SetMapByID(708) --708 for tol barad
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = ga.colors.FACTION.alliance.."Alliance"
		elseif index == 48 then
			control = ga.colors.FACTION.horde.."Horde"
		end
	end
	if not isActive then
		if (control=="|r") then
			tooltip.Line("|rControl of "..localizedName.." cannot be determined.", "WHT")
			tooltip.Line("|rYou must be in Tol Barad at least once this session.", "WHT")
		else
			tooltip.Line("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		tooltip.Line("|rThe battle for "..localizedName.." is in progress.", "WHT")
	end
	local tbl = {
		[1] = {["Short Title"]=spa.ShortName},
	}
	tooltip.Options(tbl)
	--(left,shift-left,right,shift-right,other)
	tooltip.Notes(nil,nil,"change Options",nil,nil)
	SetMapByID(area)
end

---------------------------
-- menu
---------------------------
function gf.TolBarad.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Tol Barad")
	level = level or 1
	if (level == 1) then
		gf.setMenuTitle("Tol Barad Options")
		gf.setMenuHeader("Title","title",level)
	end
	if (level == 2) then
		if gf.isMenuValue("title") then
			--checked,text,value,level,func,icon
			gf.setMenuOption(spa.ShortName==true,"TB","Short",level,function() spa.ShortName=true; gf.TolBarad.update() end)
			gf.setMenuOption(spa.ShortName==false,"Tol Barad","Long",level,function() spa.ShortName=false; gf.TolBarad.update() end)
		end
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("TolBarad")
end